; MArkanoid: Mini Arkanoid
; 4KB minigame
; by Stefano Tognon
; (C) 2003 Ice Team
; version 1.02

; Music by Luca/Fire

; Well, this year it is time to surprise
; This is my 6 game for C64

; Game concept:
;
; The game is Arkanoid: a Mini version but with great sound!
;


      processor 6502

SP0X        = $D000
SP0Y        = $D001
SP1X        = $D002
SP1Y        = $D003
SP2X        = $D004
SP2Y        = $D005
RASTER      = $D012
SPENABLE    = $D015
SPMULTIC    = $D01C
SPX_EXP     = $D01D
SP_SCOLL    = $D01E
BORDER_COL0 = $D020
BACK_COL0   = $D021
BACK_COL1   = $D022
BACK_COL2   = $D023
SP_MCOL0    = $D025
SP_MCOL1    = $D026
SP0_COL     = $D027
SP1_COL     = $D028
SP2_COL     = $D029

PUT_CHAR   = $E716    ; put a char in the screen
SCREEN     = $E544    ; clean the screen
SET_COOR   = $E50C    ; set x/y coord
GET_COOR   = $E513    ; get x/y coord
STRING     = $AB1E    ; put a string
INIT_MUSIC = $1593
PLAY_MUSIC = $1100


LEFTLIM    = 40       ; left limit value
START_LIFE =  5       ; starting life

TMPX       = $A5      ; temp value for x position
TMPY       = $A6      ; temp value for y position

TAKE       = $A7      ; take the ball flag: 0 no, 1 to take, 2 take ball, 3=take ball, but after go to 0
RIGHTLIM   = $A8      ; right limit
RELEASE    = $A9      ; when 0 release the ball even if it is with TAKE=2
TOREST     = $AA      ; 1= music 0 have to be restarted

CFROM      = $B4
CTO        = $B8

DIED       = $B1       ; 1 = died  
TMP        = $B2
COLL       = $B3       ; collision flag value
VX         = $B4       ; ball velocity with x direction
SCR        = $B5       ; actual screen
PASSED     = $B6       ; ship is passed
LIFE       = $B7       ; actual number of life
VY         = $B8       ; ball velocity with y direction
BLOCKS     = $B9       ; number of blocks remaining in this screen 
DIRECTION  = $BA       ; direction of the ship: 4 sx, 8 dx
FLIP       = $BB       ; flip: 0 normal, 1 slow
TEMP       = $BD

GO     = $BF           ; 1 = go with the game
DELAY  = $BE           ; delay for each frame

MAXDELAY  = 3          ; frame delay
BLUE      = 154        ;  1+blue
L_RIGHT   = 28         ; rigth limit of the area
STEP      = 7          ; step of the bar
STEPA     = 5          ; step of the ball
STEPB     = 2          ; step of the bonus
PO_BONUS  = $50        ; points for bonus taken
PO_BLOCK  = $1         ; points for block taken
MAXSCR    = 15         ; max number of screen 

      ;org 3840



  org 4096-64-64-64
; sprite of user bar
  .byte 0, 0, 0, 0, 0 ,0 ,0 ,0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0       
  .byte 0, 0, 0, 0, 0 ,0 ,0 ,0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 60, 0, 60
  .byte 62, 170, 188, 149, 85, 86, 126, 170, 189
  .byte 190, 170, 190, 62, 170, 188, 60, 0, 60, 0  
  
; sprite of ball  
  .byte 0, 0, 0, 0, 0 ,0 ,0 ,0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 40, 0, 0, 40, 0
  .byte 0, 150, 0, 0, 150, 0, 0, 40, 0
  .byte 0, 40, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0       
  .byte 0, 0, 0, 0, 0 ,0 ,0 ,0, 0, 0  
  
; sprite of bonus
  .byte 0, 0, 0, 0, 0 ,0 ,0 ,0, 0
  .byte 0, 0, 0, 0, 0 ,0 ,0 ,0, 0
  .byte 15, 255, 224, 63, 255, 248, 60, 68, 120
  .byte 126, 221, 252, 126, 220, 124, 254, 221, 254
  .byte 252, 68, 126, 255, 255, 254, 241, 17, 30
  .byte 247, 181, 126, 113, 179, 28, 119, 181, 124
  .byte 55, 21, 24, 63, 255, 248, 15, 255, 224, 0


  org 4096+64
  
  incbin music.bin
  
  .org $1bb3

init:

; install custom chars
                                  ; transfer characters codes to 14336
      lda  #254
      
      sta  RELEASE                ; release must be <>0 at startup: put here for saving space
      
      and  $DC0E
      sta  $DC0E
      lda  #251
      and  $01
      sta  $01
                                  ; set pointers
      lda  #$38
      sta  CTO+1
      lda  #$D0
      sta  CFROM+1
      lda  #0
      sta  CTO
      sta  CFROM
copy:                             ; copy the chars
      lda  (CFROM,x)
      sta  (CTO,x)
      inc  CFROM
      inc  CTO
      bne  copy
      inc  CFROM+1
      inc  CTO+1
      lda  CTO+1
      cmp  #$40
      bne  copy
                                  ; set pointers
      lda  #<char
      sta  CFROM
      lda  #>char
      sta  CFROM+1
      lda  #$00                   ; from char 64
      sta  CTO
      lda  #$3A
      sta  CTO+1
copy2:                            ; put the new chars
      lda  (CFROM,x)
      sta  (CTO,x)
      inc  CFROM
      inc  CTO
      bne  copy2

                                  ; restore pcr
      lda  #04
      ora  $01
      sta  $01
      lda  #01
      ora  $DC0E
      sta  $DC0E
                                  ; switch to new chars
      lda  #31
      sta  $D018
                                  ; MCM char mode
      lda  #$10
      ora  $D016
      sta  $D016

                                  ; init color ionformation
      lda  #0
      sta  BACK_COL0
      sta  BORDER_COL0

      lda  #12
      sta  BACK_COL1

      lda  #7              ; 14
      sta  BACK_COL2
      
                                  ; init sprites
      ldx  #14
      stx  SP0_COL                ; mob 0 color                           
      
      inx
      stx  SP_MCOL0               ; mob multi color 0
      
      ldx  #1
      stx  SP1_COL                ; mob 1 color

      inx
      stx  SP_MCOL1               ; mob multi color 1
      
      inx                         ; set 0 and 1 as multicolor
      stx  SPMULTIC

                                  ; insert sprite pointer to 3094+64-64
      ldx  #61
      stx  2040
      inx
      stx  2041
      inx 
      stx  2042
      
      lda  #0
      sta  TOREST                 ; music 0 is not to restart
      jsr  INIT_MUSIC
                                  ; install irq routine
      sei
      lda  #<irqR
      sta  $0314
      lda  #>irqR
      sta  $0315
                                  ; diasable cia interrupt
      ldx  #$00
      stx  $DC0E                  ; Control register A of CIA #1
      inx
      stx  $D01A                  ; IRQ mask register
      cli      
                                  ; use VIC interrupt 
      lda  #$01
      sta  $D019                  ; Interrupt indicator register
      lda  #$20
      sta  $D012                  ; Reading/Writing IRQ balance value
      lda  #$1B
      sta  $D011                  ; VIC control register   
      
      
  ;lda #$7f
  ;sta $dc0d     ; disable timer interrupts
  ;sta $dd0d
  ;ldx #1
  ;stx $d01a     ; enable raster interrupt
  ;lda $dc0d     ; acknowledge CIA interrupts
  ;lsr $d019     ; and video interrupts
               
           
      lda  #MAXDELAY              ; set frame delay
      sta  DELAY
      
                                  ; fill hi-score to 00000
      lda  #0                     ; and even score even if not necessary here 
      ldx  #6
loopFill1:      
      sta  score-1,x                                  
      dex
      bne  loopFill1

MainLoop:                         ; start/restart the game
      ldx  #0
      stx  SCR                    ; first screen to show (0)
      
      jsr  $FF9F                  ; scan for key
      ;jsr  $EEB3                  ; kernal delay 
      ;jsr  $FF9F                  ; scan for key              
      ;jsr  $F13E
      ;jsr  $F13E
      jsr  $F13E                  ; read key
      cmp  #0     
      beq  skipSecret
      
      sec
      sbc  #64
      cmp  #MAXSCR
      bcs  skipSecret
      
      sta  SCR                    ; make a selected screen (enjoy secret)

skipSecret:      
      ldx  #START_LIFE
      stx  LIFE      
                                  ; fill score to 00000
      lda  #0
      ldx  #3
loopFill:      
      sta  score-1,x                                  
      dex
      bne  loopFill

ScreenLoop:
      ldx  #0                     ; game is not yet started
      stx  GO
      stx  PASSED                 ; ship is not passed
      stx  DIED
      stx  FLIP

      lda  #BLUE
      jsr  PUT_CHAR               ; perimether is blue
      jsr  SCREEN                 ; clear the screen                                        

; make the left/right vertical line
      ldx  #24
loopLv:
      ldy  #00
      jsr  SET_COOR               ; set x/y coord
      lda  #SC_LW
      jsr  PUT_CHAR               ; put a char

      ldy  #L_RIGHT
      jsr  SET_COOR               ; set x/y coord
      lda  #SC_RW
      jsr  PUT_CHAR               ; put a char

      dex
      bpl  loopLv
 
; make top line
      ldx  #L_RIGHT-1
      lda  #SP_UW
loopT1:
      sta  1024,x
      dex
      bne  loopT1

      lda  #SP_LA
      sta  1024

      lda  #SP_RA
      sta  1024+L_RIGHT

; fill all the internal screen with the right peaces
      ldx  #1
loop2:
      ldy  #1

loop1:
      jsr  putBack

      iny
      cpy  #L_RIGHT
      bne  loop1

      inx
      cpx  #25
      bne  loop2
                                  ; put the name of the game 
      ldx  #0                    
      ldy  #30
      jsr  SET_COOR
      lda  #<Sname
      ldy  #>Sname
      jsr  STRING  
                                  ; put score string
      ldx  #7
      ldy  #32
      jsr  SET_COOR
      lda  #<Sscore
      ldy  #>Sscore
      jsr  STRING            
                                  ; put highscore string
      ldx  #11
      ldy  #30
      jsr  SET_COOR
      lda  #<Shscore
      ldy  #>Shscore
      jsr  STRING
                                  ; put expected white color over the score/highscore
      lda  #1                                                                   
      ldy  #6
loopcol:      
      sta  55296+8*40+30,y                                  
      sta  55296+12*40+30,y
      dey
      bne  loopcol     
         
      ldx  #0                     ; write the actual score  
      jsr  writeScore              
      
      ldx  #3                     ; write the actual high score
      jsr  writeScore
             
      
; show bar
      jsr  position               ; set initial bar/ball position   

      ldx  SCR                    ; skip fire if the screen is not the first
      bne  skipFire
           
      jsr  startFire              ; press fire to start    
      
      lda  TOREST
      beq  skipRestart
      
      lda  #0
      sta  TOREST
      jsr  INIT_MUSIC
      
skipRestart:   
      
      ldx  #$90
loopDel:      
      jsr  $EEB3                  ; kernal delay for key pressed released
      dex
      bne  loopDel
            
      ldx  SCR
skipFire:
      lda  lowP,x
      sta  makeScreen+1

      lda  highP,x      
      sta  makeScreen+2

makeScreen:                                 
      jsr  $6581                  ; make the selected screen

      
      lda  SCR                    ; set the number of screen
      clc
      adc  #49
      sta  Sscr+8
                                  ; write screen string
      ldx  #18
      ldy  #30
      jsr  SET_COOR
      lda  #<Sscr
      ldy  #>Sscr
      jsr  STRING 
                                  ; write life string
      ldx  #21
      ldy  #30
      jsr  SET_COOR
      lda  #<Slife
      ldy  #>Slife
      jsr  STRING
      
      lda  LIFE                   ; show current life
      clc
      adc  #48
      sta  1024+21*40+35                        
           
      inc GO                      ; game can start
      
      lda  #3                     ; take the ball
      sta  TAKE
      lda  #50                    ; for max 3 seconds
      sta  RELEASE
      
      jsr  startFire              ; press fire
      
      lda  #0
      sta  TAKE

loop:
      lda  DIED
      bne  makeDied
  
      lda  PASSED
      bne  shipPassed
      
      jmp  loop

shipPassed:
      inc  SCR                    ; pass to the next screen
      
      lda  SCR                    ; test if max screen are reached
      cmp  #MAXSCR
      bne  jumpSL
      
      lda  #1                     ; restart from screen 1
      sta  SCR
jumpSL:      
      jmp  ScreenLoop
      
makeDied:
      jsr  position               ; set ship/bar position
      
      lda  LIFE                   ; show and dec current life
      clc
      adc  #47
      sta  1024+21*40+35          
      dec  LIFE
      
      lda  BLOCKS                 ; do not close port if there are no more blocks
      beq  skipClosePort        
      
      lda  #SP_LW                 ; close the port if it was open
      sta  1984
      
skipClosePort:      
      dec  DIED
      
      lda  #0                     ; turn velocity to normal
      sta  FLIP 
      
      lda  LIFE                   ; test if we died definitely 
      beq  setHscore
            
      lda  #50                    ; 3 seconds
      sta  RELEASE
      lda  #3                     ; take the ball
      sta  TAKE      
      jsr  startFire              ; press fire for starting
      lda  #0
      sta  TAKE                   ; ball can fly

      jmp  loop        
      
setHscore:   
      lda  #1
      sta  TOREST                 ; base music have to restart
      jsr  INIT_MUSIC

      

      lda  #SP_LW                 ; close the port if it was open
      sta  1984
                       
                                  ; test if we have a new highscore
      lda  score
      cmp  score+3                                  
      bmi  notHS
      bne  setHS
      
      lda  score+1
      cmp  score+4
      bmi  notHS
      bne  setHS
      
      lda  score+2
      cmp  score+5
      bmi  notHS
      bne  setHS
                                  
notHS:
      jmp  MainLoop                ; start a new game
     
      
setHS:                             ; copy the score to hiscore 
      ldx  #3
setHS_:      
      lda  score-1,x
      sta  score+2,x
      dex
      bne  setHS_  
      jmp  notHS      

    
; set initial ship/ball position      
position:      
      lda  #228
      sta  SP0Y
      sta  SP1Y

      lda  #130
      sta  SP0X                  ; ball and ship are one over the other
      sta  SP1X

      lda  #250                  ; make the bonus not visible   
      sta  SP2Y
     
      lda  #7
      sta  SPENABLE

      lda  #STEPA
      sta  VX
      
      lda  #(255-STEPA)  ; $FA
      sta  VY
      
      jsr  beShort
      rts      
      
; put the right background peaces      
; x reg= y coord
; y reg= x coord
; we have this kind of background:
;  11 12 13 ...
;  21 22 23 ...
putBack:
      tya
      pha

      jsr  SET_COOR

      dey                         ; fisrt is not to count

loopDec:                          ; calculate 0-2 set
      cpy  #3
      bmi  isOk

      dey
      dey
      dey
      jmp  loopDec

isOk:
      sty  TMP
      txa
      lsr
      bcc  skip1

      lda  #SC_11
      bne  skip2

skip1:
      lda  #SC_21
skip2:
      clc
      adc  TMP
      jsr  PUT_CHAR

      pla
      tay
      rts

      
; interrupt routine
irqR:
                                  ; don't know why, but when the ball goes in collision
                                  ; with blocks (probably some kernal rules?), other
                                  ; interrupt (that seems raster) is trigged and music goes wrong
                                  ; this ensure to call music correctly
      lda  RASTER
      cmp  #$20
      bne  skipMusic
      
      jsr  PLAY_MUSIC    

skipMusic:       
      lda  GO
      beq  exitIrq

      dec  DELAY
      bne  exitIrq

      lda  #MAXDELAY
      sta  DELAY
      
      jsr  GET_COOR               ; this is needed, otherwise some screen bugs...
      tya                         ; appears, as the screen are update even ...
      pha                         ; off interrupt, so we save the actual...
      txa                         ; screen coordinates 
      pha
      
      lda  SP_SCOLL               ; read collision flag
      sta  COLL                   ; and remember for late use  

      jsr  userMove               ; make the move of the user
      jsr  bonusMove              ; make the move of the bonus
      

      lda  TAKE                   ; if take is 3, ball is to take 
      cmp  #3
      beq  testRelease3
      
      cmp  #2                     ; if take is 2, ball is into the ship
      beq  testRelease2

      jsr  ballMove               ; make the move of the ball
      
      ldx  #0                     ; update score string
      jsr  writeScore
      
exitIrq_:      
      pla                         ; screen coordinates are restored ... 
      tax                         ; as before the irq
      pla
      tay
      jsr  SET_COOR
    
exitIrq: 
       ldx  #1              
       stx  $d019                 ; acknowledge the raster interrupt
       
      ;jsr  $FF9F                  ; scan for key
      jmp  $ea81                  
      
testRelease3:
      dec  RELEASE                ; decreasing release time
      bne  exitIrq_
      
      lda  #0
      sta  TAKE                   ; TAKE =0 -> ball fly again
      jmp  exitIrq_            

testRelease2:      
      dec  RELEASE                ; decreasing release time
      bne  exitIrq_
      
      dec  TAKE                   ; TAKE =1 -> ball fly again
      jmp  exitIrq_


      
; look for a move from the user
userMove:
                                  ; look for direction
      lda  $DC01
      eor  #$FF
      sta  TEMP

      lda  #$04                   ; test for direct. sx
      bit  TEMP
      bne  isSx
notSx:                            ; test for direction dx 
      asl
      bit  TEMP
      bne  isDx
notDx:                            ; test for fire            
      asl
      bit  TEMP
      beq  notFire

      lda  TAKE                   ; is the ball taked by the bar?
      cmp  #2
      bne  notFire

      dec  TAKE                   ; now the ball can fly

notFire:      
      rts

      
isSx:                             ; move to sx if it is not at the left place
      lda  SP0X
      cmp  #LEFTLIM
      bcc  testOpen

goSX:
      sec
      sbc  #STEP
      sta  SP0X

      lda  TAKE                   ; is the ball attached to the ship?
      cmp  #3
      beq  attachSx
      
      cmp  #2
      bne  exSX

attachSx:      
      lda  SP1X                   ; move as the ship
      sec
      sbc  #STEP
      sta  SP1X 
exSX: 
      rts   


isDx:                             ; move to dx if it is not at the right place
      lda  SP0X
      cmp  RIGHTLIM
      bcs  exitUM

      clc
      adc  #STEP
      sta  SP0X

      lda  TAKE                   ; is the ball attached to the ship?
      cmp  #3
      beq  attachDx
      
      cmp  #2
      bne  exSX

attachDx:      
      lda  SP1X                   ; move as the ship
      clc
      adc  #STEP
      sta  SP1X 
exitUM:
      rts

testOpen:                          ; test if the port is open
      lda  1984
      cmp  #SP_EX
      bne  exitUM
                                   ; now the ship is passed
      lda  #1
      sta  PASSED
      
      lda  #1                      ; ensure that the ship pass even if it is taking tha ball
      sta  RELEASE

      lda  SP0X
      jmp  goSX


; make the move of the bonus object
bonusMove:
                                  ; the bonus is active if position is below bottom limit
      lda  SP2Y
      cmp  #250
      bcs  exitBM

      adc  #STEPB                 ; move the bonus
      sta  SP2Y
      
      lda  COLL                   ; sprite to sprite collision
      and  #$05                   ; ship and bonus sprite  
      cmp  #$05
      beq  collBonus

exitBM:
      rts


; the ship and the bonus are in collision                     
collBonus:
      lda  #PO_BONUS
      jsr  addScore               ; add points for bonus taken

      lda  #250                   ; the bonus is taken, don't show it 
      sta  SP2Y
           
      ldx  #0                     ; suppose we did not take ball
      stx  TAKE

      lda  #SP_LW                 ; always close the port
      sta  1984
      
      lda  SP2_COL                ; read the color of sprite -> type of bonus
      cmp  #$F2
      beq  beLong

      cmp  #$F3
      beq  beShort

      cmp  #$F4
      beq  openDoor
      
      cmp  #$F7
      beq  flipVel
      
; take ball     
      inx
      stx  TAKE                   ; take the ball 
      rts      
      
; be with the short ship
beShort:
      lda  #0                     ; no expansion
      sta  SPX_EXP

      ldy  #220
      bne  setLim

; be with long ship
beLong:
      lda  #1                     ; expansion
      sta  SPX_EXP

      lda  SP0X                   ; test if we are too near the right ...
      cmp  #(200-24)              ; ... wall for expanding
      bmi  skipFix

      sbc  #24                    ; shift the ship at left 
      sta  SP0X

skipFix:
      ldy  #200

setLim:
      sty  RIGHTLIM
      rts

; open the left door      
openDoor:
      lda  #SP_EX
      sta  1984
      rts         
      
; flip the velocity and direction
flipVel:          
      inc  FLIP
      rts
      
; choose a random bonus object      
chooseRandomBonus:
      lda  RASTER      
      and  #$03
      tax
      inx
      inx
      stx  SP2_COL                ; color is the type of bonus
      
      cpx  #4                     ; open port?
      bne  skipOpen

      lda  RASTER                 ; another random number
      and  #$01
      bne  skipOpen
      
      ldx  #7                     ; flip velocity and direction
      stx  SP2_COL 
      
skipOpen:            
      lda  TAKE                   ; this test if for not having a green bonus...
      beq  skipTest               ; when the ship is taking the ball...
      cpx  #5                     ; otherwise the ball will take a step up...
      bne  skipTest               ; that is not good to see
      lda  #3                     ; force to use standard ship bonus
      sta  SP2_COL
      
skipTest:      
      lda  SP1X                   ; bonus take the position of ball
      sta  SP2X
      lda  SP1Y
      sta  SP2Y
exitNN:
      rts

; make the movement of the ball
ballMove: 
      ldy  SP1Y 
      ldx  SP1X
                                  ; test if there is a lateral collision
      cpx  #25                    ; at sx
      bcs  testDX
      
      lda  #25                    ; be sure that the ball did not collide ...
      sta  SP1X                   ; again at sx (if it was too much at sx)
      
      jsr  changeDirX
      bne  testOrriz

testDX:
      cpx  #232                   ; at dx
      bcc  testOrriz
      
      lda  #232                   ; be sure that the ball did not collide ...
      sta  SP1X                   ; again at dx (if it was too much at dx)      
      jsr  changeDirX

testOrriz:
      cpy  #54                    ; at up
      bcs  testShip

      jsr  changeDirY

testShip:                         ; test if ball is in collision with the ship
      lda  COLL
      and  #3
      cmp  #3
      bne  exitTS
      
      lda  TAKE                   ; if take is 1 and ball is in collision with the ship...
      cmp  #1
      bne  contDir
      
      inc  TAKE                   ; ...take must be 2
      
      lda  #50                    ; rekease the ball after 50/50*3=3 seconds
      sta  RELEASE

contDir:
      lda  FLIP                   ; actual flip direction
      lsr
      bcs  lowVel

      ;jsr  changeDirY            ; this left some errors in movement...
      lda  #(255-STEPA)           ; ... so I use to put always the direction to up
      bne  staVel
      
lowVel:
      lda  #(255-STEPA+3)         ; use low y-velocity
staVel:      
      sta  VY

      lda  SP1Y                   ; make y movement
      clc
      adc  VY
      sta  SP1Y

testCSX:
      lda  SP0X                   ; if ball is collided at sx of ship, it changes X direction...
      sbc  SP1X
      sbc  #5
      bmi  testCDX
                                  ; ...but only if ball goes from sx to dx
      lda  VX
      bmi  exitTS               
 
chDX:
      jsr  changeDirX
      jmp  exitTS

testCDX:
      lda  SP1X
      sbc  SP0X

      ldx  SPX_EXP                ; is the ship expanded?
      bne  testExpCDX
                                  ; no, not expanded
      sbc  #10                    ; if ball is collided at dx of ship, it changes X direction...
      bmi  exitTS
                                  ; ...but only if ball goes from sx to dx
      lda  VX
      bpl  exitTS 
      jmp  chDX                      
                                  ; yes, expanded
testExpCDX:
      sbc  #25                    ; if ball is collided at dx of ship, it changes X direction...
      bmi  exitTS
                                  ; ...but only if ball goes from sx to dx
      lda  VX
      bpl  exitTS 
      jmp  chDX        
 


exitTS:
      lda  SP1X                   ; make x movement
      clc
      adc  VX
      sta  TMPX

      lda  SP1Y                   ; make y movement
      clc
      adc  VY
      ;sta  TMPY
      tay

      lda  TAKE                   ; if take is now 2 we must exit..
      cmp  #2                     ; but future direction is now good
      beq  exitTSA

      sty  SP1Y
      lda  TMPX
      sta  SP1X 

      cpy  #250                   ; test for died
      bcs  died

                                  ; test if now we are into a block
      ldy  SP1X
      ldx  SP1Y
      jsr  blockCollision
      beq  exitTSA     
                                  ; we are in collision with a block                                                                                                       
      cmp  #9                     ; test if color is white              
      bne  rback
      
      jsr  restoreBlock           ; restore block in yellow
      jmp  srback    
      
rback:      
      jsr  restoreBack            ; restore the background below the block
      
srback:      
      lda  #PO_BLOCK              ; add points for block taken
      jsr  addScore                   
      
      ldy  #0                     ; last block taken indicator      
      dec  BLOCKS
      bne  goChange
     
      lda  #SP_EX                 ; open the port
      sta  1984
 
      lda  #250                   ; make the bonus not visible   
      sta  SP2Y
      iny                         ; and not choose another one 
goChange:
      jsr  changeDirY
 
      lda  SP2Y                   ; is a bonus already visible?
      cmp  #250
      bcc  exitTSA
      
      cpy  #0                     ; skip if it was the last block
      bne  exitTSA
                                  ; no, show one
      jsr  chooseRandomBonus

exitTSA:
      rts


; change x direction
changeDirX:
      lda  VX                     ; make complement 2 of direction x
      eor  #$FF
      sec
      adc  #00
      sta  VX
      rts

; change y direction
changeDirY:                       ; make complement 2 of direction y
      lda  VY
      eor  #$FF
      sec
      adc  #00
      sta  VY
      rts


died:
      ldx  #1
      stx  DIED                   ; we are died ...
      inx
      stx  TAKE                   ; and so take the ball...
      rts

; verify if the ball is in collision with a block
; x the y coord of the ball sprite
; y the x coord of the ball sprite
; return C<>0 if it is in collision
blockCollision:
      txa
      sbc  #38; #39
      lsr
      lsr
      lsr
      tax

      tya
      sbc  #18; #20
      lsr
      lsr
      lsr
      tay

      jsr  SET_COOR               ; this set F3/F4 to color ram position
      lda  ($F3),y                ; read color in the cursor screen position
      and  #$0F
      cmp  #$0E                   ; blue color

      rts


; create part of screen
; 6 rows of 9 blocks
; x= initial position of the block
createPart:
      lda  #158                   ; yellow
      ldy  #1
      jsr  orrizBlock
      
      lda  #159                   ; cyan
      inx
      ldy  #1
      jsr  orrizBlock
      
      lda  #156                   ; purple
      inx
      ldy  #1
      jsr  orrizBlock
      
      lda  #150                   ; red
      inx
      ldy  #1
      jsr  orrizBlock
      
      lda  #153                   ; green
      inx
      ldy  #1
      jsr  orrizBlock

      lda  #149                   ; white
      inx
      ldy  #1
      jsr  orrizBlock

      rts


      
; create the first screen:
; 6 rows of 9 blocks
createSC0:
      ldx  #4
      jsr  createPart

      lda  #(9*6+9)               ; set the number of blocks in this screen
      sta  BLOCKS
      rts

; create the second screen:
;       
createSC1:
      lda  #153                   ; green
      ldx  #2
      ldy  #19
      jsr  vertBlock

      ldx  #2
      ldy  #7
      jsr  vertBlock      
      
      ldx  #4
      lda  #158                   ; yellow
      ldy  #1
      jsr  orrizBlock
      
      ldx  #9
      lda  #150                   ; red
      ldy  #1
      jsr  orrizBlock      
      
      ldx  #13
      lda  #149                   ; white      
      ldy  #1
      jsr  orrizBlock  
         
      lda  #60                    ; set the number of blocks in this screen
      sta  BLOCKS             
      rts

; create 3 screen    
createSC2:
      lda  #158                   ; yellow
      ldx  #2
      ldy  #1
      jsr  vertBlock
      
      lda  #159                   ; cyan
      ldx  #2
      ldy  #7
      jsr  vertBlock
      
      lda  #156                   ; purple
      ldx  #2
      ldy  #13
      jsr  vertBlock
      
      lda  #150                   ; red
      ldx  #2
      ldy  #19
      jsr  vertBlock
      
      lda  #153                   ; green
      ldx  #2
      ldy  #25
      jsr  vertBlock
      
      lda  #(15*5)                ; set the number of blocks in this screen
      sta  BLOCKS     
      rts      

; create 4 screen      
createSC3:
      lda  #153                   ; green
      ldx  #2
      ldy  #4
      jsr  orrizBlock           
      ldy  #4
      jsr  vertBlock
      
      lda  #156                   ; purple
      ldx  #4
      ldy  #10
      jsr  orrizBlock     
      ldy  #10
      jsr  vertBlock    
      
      lda  #159                   ; cyan
      ldx  #6
      ldy  #16
      jsr  orrizBlock     
      ldy  #16
      jsr  vertBlock   
      
      lda  #150                   ; red
      ldx  #8
      ldy  #22
      jsr  orrizBlock     
      ldy  #22
      jsr  vertBlock    
      
      lda  #(64)                  ; set the number of blocks in this screen
      sta  BLOCKS                
      rts      

      
; create 6 screen
createSC5:
      ldx  #11
      ldy  #$FE
      lda  #9
      sta  TMP
      lda  #156                   ; purple
      jsr  scLoop
      
      ldx  #13
      ldy  #$FE
      lda  #9
      sta  TMP
      lda  #149                   ; white
      jsr  scLoop
      
      ldx  #15
      ldy  #$FE
      lda  #9
      sta  TMP
      lda  #159                   ; cyan
      jsr  scLoop   
      
      ldx  #17
      ldy  #$FE
      lda  #9
      sta  TMP
      lda  #150                   ; red
      jsr  scLoop  
      
      ldx  #19
      ldy  #$FE
      lda  #9
      sta  TMP
      lda  #149                   ; white
      jsr  scLoop
      
      lda  #(63)                  ; set the number of blocks in this screen
      sta  BLOCKS  
      rts      
   
; create 7 screen        
createSC6:
      ldx  #11
      ldy  #$FE
      lda  #9
      sta  TMP
      lda  #149                   ; white
      jsr  scLoop
      
      ldx  #11   
      ldy  #1
      jsr  orrizBlock  
      
      ldx  #2
      ldy  #25
      jsr  vertBlock       

      lda  #150                   ; red      
      ldx  #13   
      ldy  #1
      jsr  orrizBlock 
      
      lda  #156                   ; purple      
      ldx  #15  
      ldy  #1
      jsr  orrizBlock                    
          
      lda  #(76)                  ; set the number of blocks in this screen
      sta  BLOCKS
      rts
      
      
; create a line that go from down to up      
scLoop:
      iny
      iny
      iny
      dex
      jsr  putBlock
      dec  TMP
      bne  scLoop
      rts
      
; create a line that go from up to down 
scLoop_:
      dey
      dey
      dey
      dex
      jsr  putBlock
      dec  TMP
      bne  scLoop_
      rts        
      
; create a line 
scLoop__:
      iny
      iny
      iny
      inx
      jsr  putBlock
      dec  TMP
      bne  scLoop__
      rts      
           
; create 8 screen
createSC7:
      jsr  createSC3
      lda  #149                   ; white 
      ldy  #4
      ldx  #17
      jsr  orrizBlock
              
      lda  #(80)                  ; set the number of blocks in this screen
      sta  BLOCKS                 
      rts
          
; create 9 screen:
; 6+6 rows of 9 blocks
createSC8:
      jsr  createSC0
      inx
      inx
      jsr  createPart

      lda  #(18*6+18)             ; set the number of blocks in this screen
      sta  BLOCKS 
      rts

; write orriz. block until last coloumn      
orrizBlock:      
loopB1:      
      jsr  putBlock
      iny
      iny
      iny
      cpy  #28
      bne  loopB1      
      rts

; write vertical block until some limit            
vertBlock:
loopB2:
      jsr  putBlock
      inx
      cpx  #17
      bne  loopB2
      rts
                  
; put a block starting on the passed X/Y position and A color      
putBlock:
      pha
      pha
      jsr  SET_COOR
      pla
      jsr  PUT_CHAR
      lda  #SC_LB
      jsr  PUT_CHAR
      lda  #SC_CB
      jsr  PUT_CHAR
      lda  #SC_RB
      jsr  PUT_CHAR
      pla
      rts      

; restore the background graphics onto a block.
; x/y the x/y coord of one chars of the block       
restoreBack:
      lda  #BLUE
      jsr  PUT_CHAR               ; change background color 

      tya      
      ;dey                         ; first is not to count
      
another:      
      dey
      beq  isPos1
      
      dey
      beq  isPos2
      
      dey
      beq  isPos3
      bne  another
      
isPos1:
      tay
      bne  writeB
      
isPos2:
      tay
      dey
      bne  writeB
      
isPos3:
      tay
      dey
      dey

writeB:
      jsr  putBack
      iny
      jsr  putBack
      iny
      jsr  putBack
      rts                                                         
      
; restore a white block to yellow.
; x/y the x/y coord of one chars of the block       
restoreBlock:
      lda  #158                   ; yellow
      jsr  PUT_CHAR               ; change background color 

      tya      
      ;dey                         ; first is not to count
      
another_:      
      dey
      beq  isPos1_
      
      dey
      beq  isPos2_
      
      dey
      beq  isPos3_
      bne  another_
      
isPos1_:
      tay
      bne  writeB_
      
isPos2_:
      tay
      dey
      bne  writeB_
      
isPos3_:
      tay
      dey
      dey

writeB_:                          ; write the block again in yellow
      jsr  SET_COOR
      lda  #SC_LB
      jsr  PUT_CHAR
      iny
      lda  #SC_CB
      jsr  PUT_CHAR
      iny
      lda  #SC_RB
      jsr  PUT_CHAR
      rts                                                            
      
; press fire to start
startFire:   
      lda  #5                    ; write fire screen with white color
      sta  Sfire
      jsr  writeFire  
      
repeatF:                         ; attend a fire press action    
      lda  TAKE                  ; if take is 0, ball is flying by interrupt
      cmp  #0
      beq  exitFire 

      lda  $DC01
      and  #16
      bne  repeatF 
exitFire:      
     
      lda  #144                  ; write fire screen with black color = erase previous
      sta  Sfire
      jsr  writeFire

      rts

; write press fire screen
writeFire:
      ; write fire string
      ldx  #23
      ldy  #30
      jsr  SET_COOR
      lda  #<Sfire
      ldy  #>Sfire
      jsr  STRING 
      rts

; write score
; x=0/3 0 for score, 3 for highscore
writeScore:
      ldy  #0
     
      lda  #$5F                   ; this is the low address for score ($55F)
      cpx  #3
      bne  skipws
     
      lda  #$FF                   ; this is the high address for hiscore ($5FF) 
skipws:
      sta  wra1+1                 ; change low address as needed
      sta  wra2+1   
     
loopws     
      lda  score,x
      pha
      lsr
      lsr
      lsr
      lsr
      clc
      adc  #48
wra1:     
      sta  1024+8*40+31,y
      iny
      pla
      and  #$0F
      clc
      adc  #48
wra2:     
      sta  1024+12*40+31,y
      inx
      iny
      cpy  #6
      bne  loopws
      rts      

; add points to score
; A=point to add     
addScore:
      ldx  #2
      ldy  #0                     ; clear carry indicator
      sed                         ; decimal mode
      clc
      adc  score,x
      sta  score,x
      bcc  exitscore
     
      iny                         ; carry indicator
      dex
      lda  #0
      adc  score,x
      sta  score,x
      bcc  exitscore
     
      dex
      lda  #0
      adc  score,x
      sta  score,x     
exitscore:     
      cld                         ; normal mode
     
      cpy  #0                     ; test carry indicator
      beq  skipAS
     
      lda  score+1                ; read middle of score
      and  #$3F
      cmp  #$20
      bne  skipAS                 ; if $20, we have reach another 2000 points
     
      lda  LIFE
      cmp  #9
      beq  skipAS                 ; we cannot have more then 9 lifes
     
      inc  LIFE                   ; get an extra life
                                  ; write life string
      lda  LIFE                   ; show current life
      clc
      adc  #48
      sta  1024+21*40+35
skipAS:     
      rts          
       
           
Sfire:   .byte 5,"PRESS FIRE",0
Sscr:    .byte 5,"SCREEN  ",0
Slife:   .byte 5,"LIFE ",START_LIFE+48,0
Sname:   .byte 5,"MARKANOID",0
Sscore:  .byte 5,"SCORE",0
Shscore: .byte 5,"HIGHSCORE",0


; chars definitios (Multicolor text mode)
; 00:  black
; 01:  grey 2
; 10:  7

 .org $2400
char:

; left of a block
SC_LB = 96
  .byte $00   ; 00 00 00 00
  .byte $3F   ; 00 11 11 11
  .byte $3F   ; 00 11 11 11
  .byte $3F   ; 00 11 11 11
  .byte $3F   ; 00 11 11 11
  .byte $3F   ; 00 11 11 11
  .byte $3F   ; 00 11 11 11
  .byte $00   ; 00 00 00 00
  
; center of a block
SC_CB = 97
  .byte $00   ; 00 00 00 00
  .byte $FF   ; 11 11 11 11
  .byte $FF   ; 11 11 11 11
  .byte $FF   ; 11 11 11 11
  .byte $FF   ; 11 11 11 11
  .byte $FF   ; 11 11 11 11
  .byte $FF   ; 11 11 11 11
  .byte $00   ; 00 00 00 00  

; right of a block
SC_RB = 98
  .byte $00   ; 00 00 00 00
  .byte $FC   ; 11 11 11 00
  .byte $FC   ; 11 11 11 00
  .byte $FC   ; 11 11 11 00
  .byte $FC   ; 11 11 11 00
  .byte $FC   ; 11 11 11 00
  .byte $FC   ; 11 11 11 00
  .byte $00   ; 00 00 00 00

; left wall
SC_LW = 99
SP_LW = 67
  .byte $3B   ; 00 11 10 11
  .byte $3B   ; 00 11 10 11
  .byte $3B   ; 00 11 10 11
  .byte $3B   ; 00 11 10 11
  .byte $3B   ; 00 11 10 11
  .byte $3B   ; 00 11 10 11
  .byte $3B   ; 00 11 10 11
  .byte $3B   ; 00 11 10 11

; right wall
SC_RW = 100
SP_RW = 68
  .byte $EC   ; 11 10 11 00
  .byte $EC   ; 11 10 11 00
  .byte $EC   ; 11 10 11 00
  .byte $EC   ; 11 10 11 00
  .byte $EC   ; 11 10 11 00
  .byte $EC   ; 11 10 11 00
  .byte $EC   ; 11 10 11 00
  .byte $EC   ; 11 10 11 00

; up wall
SC_UW = 101
SP_UW = 69
  .byte $00   ; 00 00 00 00
  .byte $FF   ; 11 11 11 11
  .byte $AA   ; 10 10 10 10
  .byte $55   ; 01 01 01 01
  .byte $FF   ; 11 11 11 11
  .byte $FF   ; 11 11 11 11
  .byte $FF   ; 11 11 11 11
  .byte $00   ; 00 00 00 00
  
; left angle
SC_LA = 102
SP_LA = 70
  .byte $00   ; 00 00 00 00
  .byte $3F   ; 00 11 11 11
  .byte $3A   ; 00 11 10 10
  .byte $39   ; 00 11 10 01
  .byte $3B   ; 00 11 10 11
  .byte $3B   ; 00 11 10 11
  .byte $3B   ; 00 11 10 11
  .byte $3B   ; 00 11 10 11
  
; right angle
SC_RA = 103
SP_RA = 71
  .byte $00   ; 00 00 00 00
  .byte $FC   ; 11 11 11 00
  .byte $AC   ; 10 10 11 00
  .byte $6C   ; 01 10 11 00
  .byte $EC   ; 11 10 11 00
  .byte $EC   ; 11 10 11 00
  .byte $EC   ; 11 10 11 00
  .byte $EC   ; 11 10 11 00

; piece 1-1      
SC_11 = 104
SP_11 = 72
  .byte $FD   ; 11 11 11 01
  .byte $FD   ; 11 11 11 01  
  .byte $F6   ; 11 11 01 10
  .byte $F6   ; 11 11 01 10  
  .byte $DA   ; 11 01 10 10
  .byte $DA   ; 11 01 10 10  
  .byte $6A   ; 01 10 10 10 
  .byte $6A   ; 01 10 10 10 
  
; piece 1-2
SC_12 = 105
SP_12 = 73
  .byte $55   ; 01 01 01 01
  .byte $FC   ; 11 11 11 00
  .byte $FC   ; 11 11 11 00
  .byte $F3   ; 11 11 00 11
  .byte $F0   ; 11 11 00 00
  .byte $C3   ; 11 00 00 11
  .byte $Cc   ; 11 00 11 00
  .byte $03   ; 00 00 00 11

; piece 1-3  
SC_13 = 106
SP_13 = 74
  .byte $7F   ; 01 11 11 11
  .byte $7F   ; 01 11 11 11
  .byte $DF   ; 11 01 11 11
  .byte $1F   ; 00 01 11 11
  .byte $C7   ; 11 00 01 11
  .byte $37   ; 00 11 01 11
  .byte $CD   ; 11 00 11 01
  .byte $31   ; 00 11 00 01

; piece 2-1
SC_21 = 107
SP_21 = 75
  .byte $7F   ; 01 11 11 11 
  .byte $7F   ; 01 11 11 11
  .byte $DF   ; 11 01 11 11
  .byte $DF   ; 11 01 11 11
  .byte $F7   ; 11 11 01 11
  .byte $F7   ; 11 11 01 11
  .byte $FD   ; 11 11 11 01
  .byte $FD   ; 11 11 11 01
  
; piece 2-2
SC_22 = 108
SP_22 = 76
  .byte $33   ; 00 11 00 11
  .byte $Cc   ; 11 00 11 00
  .byte $C3   ; 11 00 00 11
  .byte $F0   ; 11 11 00 00
  .byte $F3   ; 11 11 00 11
  .byte $FC   ; 11 11 11 00
  .byte $FC   ; 11 11 11 00
  .byte $FF;  ; 11 11 11 11    55   ; 01 01 01 01
  
; piece 2-3
SC_23 = 109
SP_23 = 77
  .byte $C1   ; 11 00 00 01
  .byte $31   ; 00 11 00 01
  .byte $c7   ; 11 00 01 11
  .byte $37   ; 00 11 01 11
  .byte $1F   ; 00 01 11 11
  .byte $DF   ; 11 01 11 11
  .byte $7F   ; 01 11 11 11
  .byte $7F   ; 01 11 11 11

; exit
SC_EX = 110
SP_EX = 78
  .byte $10 ; 00 01 00 00
  .byte $04 ; 00 00 01 00
  .byte $10 ; 00 01 00 00
  .byte $04 ; 00 00 01 00
  .byte $10 ; 00 01 00 00
  .byte $04 ; 00 00 01 00
  .byte $10 ; 00 01 00 00
  .byte $04 ; 00 00 01 00


; create 5 screen      
createSC4:     
      ldx  #11
      ldy  #$FE
      lda  #5
      sta  TMP
      lda  #149                   ; white
      jsr  scLoop  
      lda  #4
      sta  TMP
      lda  #149                   ; white      
      jsr  scLoop_
      
      ldx  #11
      ldy  #$04
      lda  #5
      sta  TMP
      lda  #156                   ; purple
      jsr  scLoop  
      lda  #4
      sta  TMP
      lda  #159                   ; cyan      
      jsr  scLoop_      
      
      ldx  #11
      ldy  #$0a
      lda  #5
      sta  TMP
      lda  #149                   ; white
      jsr  scLoop  
      lda  #4
      sta  TMP
      lda  #149                   ; white      
      jsr  scLoop_              
      
      lda  #(45)                  ; set the number of blocks in this screen
      sta  BLOCKS  
      rts

; create screen 11            
createSC10:
      jsr  createSC4
      
      lda  #159                   ; cyan
      ldx  #14
      ldy  #1
      jsr  orrizBlock
      
      lda  #156                   ; purple
      inx
      ldy  #1
      jsr  orrizBlock
      
      lda  #150                   ; red
      inx
      ldy  #1
      jsr  orrizBlock    
        
      lda  #(72)                  ; set the number of blocks in this screen
      sta  BLOCKS        
      rts
      
createSC9:
      ldx  #9
      ldy  #$FE
      lda  #5
      sta  TMP
      lda  #149                   ; white
      jsr  scLoop  
      lda  #4
      sta  TMP
      lda  #149                   ; white      
      jsr  scLoop__
      
      ldx  #12
      ldy  #$FE
      lda  #5
      sta  TMP
      lda  #156                   ; purple
      jsr  scLoop  
      lda  #4
      sta  TMP
      lda  #156                   ; purple     
      jsr  scLoop__      
      
      ldx  #15
      ldy  #$FE
      lda  #5
      sta  TMP
      lda  #153                   ; green
      jsr  scLoop  
      lda  #4
      sta  TMP
      lda  #153                   ; green     
      jsr  scLoop__ 
      
      lda  #(36)                  ; set the number of blocks in this screen
      sta  BLOCKS                 
      rts      
      
; create screen 11      
createSC11:
      lda  #159                   ; cyan
      ldx  #6
      ldy  #1
      jsr  orrizBlock
      
      lda  #156                   ; purple
      inx
      ldy  #1
      jsr  orrizBlock
      
      lda  #150                   ; red
      inx
      ldy  #1
      jsr  orrizBlock    
      
      ldx  #14
      ldy  #$FE
      lda  #5
      sta  TMP
      lda  #153                   ; green
      jsr  scLoop  
      lda  #4
      sta  TMP
      lda  #153                   ; green     
      jsr  scLoop__ 
      
      ldx  #16
      ldy  #$FE
      lda  #5
      sta  TMP
      lda  #149                   ; white
      jsr  scLoop  
      lda  #4
      sta  TMP
      lda  #149                   ; white      
      jsr  scLoop__           
        
      lda  #(54)                  ; set the number of blocks in this screen
      sta  BLOCKS
      rts      
      
createSC12:
      lda  #153                   ; green
      ldx  #1
      ldy  #19
      jsr  vertBlock
      
      lda  #153                   ; green
      ldx  #1
      ldy  #7
      jsr  vertBlock    
      
      ldx  #14
      ldy  #$FE
      lda  #5
      sta  TMP
      lda  #150                   ; red
      jsr  scLoop  
      lda  #4
      sta  TMP
      lda  #150                   ; red     
      jsr  scLoop__ 
      
      ldx  #16
      ldy  #$FE
      lda  #5
      sta  TMP
      lda  #149                   ; white
      jsr  scLoop  
      lda  #4
      sta  TMP
      lda  #149                   ; white      
      jsr  scLoop__         

      lda  #(55)                  ; set the number of blocks in this screen
      sta  BLOCKS
      rts
            
createSC13:
      lda  #149                   ; white 
      ldx  #10
      ldy  #10
      jsr  putBlock
      inx
      jsr  putBlock
      iny    
      iny
      iny  
      jsr  putBlock
      dex
      jsr  putBlock            
      iny    
      iny
      iny  
      jsr  putBlock 
      inx
      jsr  putBlock            
      
      lda  #(12)                  ; set the number of blocks in this screen
      sta  BLOCKS
      rts      
      
; low pointers table for screen creation routines
lowP:
  ;.byte <createSC13
  
  .byte <createSC0
  .byte <createSC1
  .byte <createSC2
  .byte <createSC3 
  .byte <createSC4  
  .byte <createSC5  
  .byte <createSC6
  .byte <createSC7
  .byte <createSC8
  .byte <createSC9  
  .byte <createSC10
  .byte <createSC11
  .byte <createSC12    
  .byte <createSC13
        
  .byte <createSC0      ; this is because screen 1 is not showed when looping    

; high pointers table for screen creation routines
highP:
  ;.byte >createSC13

  .byte >createSC0
  .byte >createSC1
  .byte >createSC2
  .byte >createSC3  
  .byte >createSC4  
  .byte >createSC5  
  .byte >createSC6 
  .byte >createSC7 
  .byte >createSC8
  .byte >createSC9    
  .byte >createSC10
  .byte >createSC11  
  .byte >createSC12
  .byte >createSC13
        
  .byte >createSC0      ; this is because screen 1 is not showed when looping  

  
  ; secret string for filling the space I have, but the sending time is ending...
  .byte "ENJOY SID MUSIC FOREVER"  
  
; here we have the memory for the score:
; xx     high       \ 
; xx+1   medium     | of score
; xx+2   low        /

; xx+3   high       \ 
; xx+4   medium     | of high score
; xx+5   low        /
; they are not initialized for save memory
; and so they are equal to 0 only after that the machine started up
score:
 
